//
//  main.c
//  study
//
//  Created by 國居 貴浩 on 12/01/05.
//  Copyright (c) 2012年 TETERA. All rights reserved.
//

#include <stdio.h>

#define MAX_LEN 100
typedef struct {
    int     shift;
    char    text[MAX_LEN];
} CipherText;

void cipher(const char * plain_text, int shift, CipherText * cipher);
void decipher(const CipherText * cipher, char * plain_text);


//  暗号化する
void cipher(const char * plain_text, int shift, CipherText * ioCipher)
{
    ioCipher->shift = shift;
    for (int i = 0; i < MAX_LEN; i++) {
        ioCipher->text[i] = *plain_text + ioCipher->shift;    	// 1文字暗号化する。
        if (*plain_text == 0) {
            ioCipher->text[i] = 0;               		// 暗号化のせいで終端まで3になっているのを修正。
            break;                              		// 文字は0だったので、ここでループを強制終了する。
        }
        plain_text++;                           		// 次の文字にすすめる。
    }
}

// 暗号を解く
void decipher(const CipherText * cipher, char * plain_text)
{
    for (int i = 0; i < MAX_LEN; i++) {
        if (cipher->text[i] == 0) {
            plain_text[i] = 0;                 		// 終端は 0　のままでよい。
            break;                             		// 文字は0だったので、ここでループを強制終了する。
        }
        plain_text[i] = cipher->text[i] - cipher->shift;   	// 1文字、暗号を解く。
    }
}

int main (int argc, const char * argv[])
{
    CipherText a, b;
    char plain[MAX_LEN];
    
    cipher("HELLO WORLD", 3, &a);                   //  CipherText構造体をポインタ型で渡している。
    decipher(&a, plain);
    printf("%s = %s\n", plain, a.text);

    cipher("HELLO WORLD", 4, &b);                   //  CipherText構造体をポインタ型で渡している。
    decipher(&b, plain);
    printf("%s = %s\n", plain, b.text);
    return 0;
}
